package com.iot.modbus_rtcp.dto;

import lombok.Data;
import lombok.Getter;
import lombok.NoArgsConstructor;
import lombok.ToString;
import lombok.experimental.SuperBuilder;

@Data
@SuperBuilder
@NoArgsConstructor
@ToString(callSuper = true)
public class CommandTypeComparable implements Comparable {
    private CommandType type;

    private long timestamp;

    @Override
    public int compareTo(Object o) {
        CommandTypeComparable commandTypeComparable = (CommandTypeComparable) o;

        if (this.getType() == commandTypeComparable.getType()) {
            return this.timestamp > commandTypeComparable.timestamp ? 1 : -1;
        } else if (this.getType() == CommandType.CONTROL) {
            return -1;
        } else if (this.getType() == CommandType.COLLECTION) {
            return 1;
        } else {
            throw new RuntimeException("无法排序");
        }
    }

    @Getter
    public enum CommandType {
        CONTROL("控制"), COLLECTION("采集");

        private final String name;

        CommandType(String name) {
            this.name = name;
        }
    }
}
