package com.iot.modbus_rtcp.netty;

import lombok.extern.slf4j.Slf4j;
import org.springframework.scheduling.concurrent.ThreadPoolTaskExecutor;

@Slf4j
public class ThreadPoolConsumer {
    private static final ThreadPoolTaskExecutor mThreadPoolExecutor;

    static {
        mThreadPoolExecutor = new ThreadPoolTaskExecutor();
        mThreadPoolExecutor.setQueueCapacity(5000);
        mThreadPoolExecutor.setKeepAliveSeconds(60);
        mThreadPoolExecutor.setThreadPriority(Thread.MAX_PRIORITY);
        mThreadPoolExecutor.setThreadNamePrefix("Modbus-command-sender-thread-");
        mThreadPoolExecutor.setCorePoolSize(Math.min(50, Runtime.getRuntime().availableProcessors() - 1));
        mThreadPoolExecutor.setMaxPoolSize(Math.min(500, Runtime.getRuntime().availableProcessors() * 10));
        mThreadPoolExecutor.initialize();
    }

    public static void submit(Runnable task) {
        mThreadPoolExecutor.submit(task);
    }

    public static void shutdown() {
        mThreadPoolExecutor.shutdown();
    }

}
