package com.iot.modbus_rtcp.utils;

import org.bouncycastle.pqc.math.linearalgebra.ByteUtils;

public class CRCUtil {
    public static String getCRC(byte[] bytes, boolean cvs) {
        int CRC = 0x0000ffff;
        int POLYNOMIAL = 0x0000a001;

        int i, j;
        for (i = 0; i < bytes.length; i++) {
            CRC ^= ((int) bytes[i] & 0x000000ff);
            for (j = 0; j < 8; j++) {
                if ((CRC & 0x00000001) != 0) {
                    CRC >>= 1;
                    CRC ^= POLYNOMIAL;
                } else {
                    CRC >>= 1;
                }
            }
        }

        if (cvs) {
            CRC = ((CRC & 0x0000FF00) >> 8) | ((CRC & 0x000000FF) << 8);
        }

        return String.format("%04x", CRC).toUpperCase();
    }

    public static String getCRC(byte[] bytes) {
        return getCRC(bytes, true);
    }

    public static boolean verifyCRC(byte[] bytes) {
        byte[] crc = ByteUtils.subArray(bytes, bytes.length - 2, bytes.length);
        byte[] data = ByteUtils.subArray(bytes, 0, bytes.length - 2);

        String generate = CRCUtil.getCRC(data);
        String original = HexUtil.bytesToHexString(crc);

        return original.equalsIgnoreCase(generate);
    }

    public static void main(String[] args) {
        String[] array = new String[]{"0A0300000019", "0A0303930023", "0A0301A4002D", "0A0301D6002D", "0A0300320064", "0A0300960064", "0A0300FA0064", "0A03015E0064", "0A0200000050"};
        for (String str : array) {
            System.out.println(str + CRCUtil.getCRC(HexUtil.hexStringToBytes(str)));
        }
    }
}
